Subject: [IPP] Fwd: [dispatch] draft-ietf-6man-rfc6874bis-00.txt

From: ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]>
Date: Sun, 20 Mar 2022 16:02:23 -0400

FYI - potential new breakage in IPv6 literals in URIs - probably impacts
printers.

---------- Forwarded message ---------
From: Brian E Carpenter <[email-masked]>
Date: Sun, Mar 20, 2022 at 3:36 PM
Subject: [dispatch] Fwd: I-D Action: draft-ietf-6man-rfc6874bis-00.txt
To: <[email-masked]>

FYI, 6MAN has now adopted this draft. There's also a simplification of the
security considerations, following a perceptive comment by Ted Hardie.

As a reminder, we are not asking for action by DISPATCH, but of course
we'd welcome feedback.

Regards
    Brian Carpenter

-------- Forwarded Message --------
Subject: I-D Action: draft-ietf-6man-rfc6874bis-00.txt
Date: Sun, 20 Mar 2022 04:17:34 -0700
From: [email-masked]
Reply-To: [email-masked], [email-masked]
To: [email-masked]
CC: [email-masked]

A New Internet-Draft is available from the on-line Internet-Drafts
directories.
This draft is a work item of the IPv6 Maintenance WG of the IETF.

         Title           : Representing IPv6 Zone Identifiers in Address
Literals and Uniform Resource Identifiers
         Authors         : Brian Carpenter
                           Stuart Cheshire
                           Robert M. Hinden
        Filename        : draft-ietf-6man-rfc6874bis-00.txt
        Pages           : 11
        Date            : 2022-03-19

Abstract:
    This document describes how the zone identifier of an IPv6 scoped
    address, defined as <zone_id> in the IPv6 Scoped Address Architecture
    (RFC 4007), can be represented in a literal IPv6 address and in a
    Uniform Resource Identifier that includes such a literal address.  It
    updates the URI Generic Syntax and Internationalized Resource
    Identifier specifications (RFC 3986, RFC 3987) accordingly, and
    obsoletes RFC 6874.

The IETF datatracker status page for this draft is:
https://datatracker.ietf.org/doc/draft-ietf-6man-rfc6874bis/

There is also an HTML version available at:
https://www.ietf.org/archive/id/draft-ietf-6man-rfc6874bis-00.html

Internet-Drafts are also available by rsync at rsync.ietf.org:
:internet-drafts

_______________________________________________
I-D-Announce mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/i-d-announce
Internet-Draft directories: http://www.ietf.org/shadow.html
or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

_______________________________________________
dispatch mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/dispatch
_______________________________________________
ipp mailing list
[email-masked]
https://www.pwg.org/mailman/listinfo/ipp

---

From: ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]>
Date: Sun, 20 Mar 2022 20:32:50 +0000

I seem to recall that Mike had some views or opinions in this area, that differed from what the RFCs were specifying. Mike, what is your impression of this IETF proposal?

Smith

/**
    Smith Kennedy
    HP Inc.
*/

> On Mar 20, 2022, at 4:02 PM, ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]> wrote:
> 
> FYI - potential new breakage in IPv6 literals in URIs - probably impacts printers.
> 
> From: Brian E Carpenter <[email-masked] <mailto:[email-masked]>>
> To: <[email-masked] <mailto:[email-masked]>>
> 
> 
> From: [email-masked] <mailto:[email-masked]>
> Reply-To: [email-masked] <mailto:[email-masked]>, [email-masked] <mailto:[email-masked]>
> To: [email-masked] <mailto:[email-masked]>
> CC: [email-masked] <mailto:[email-masked]>
> 
> 
> A New Internet-Draft is available from the on-line Internet-Drafts directories.
>          Title           : Representing IPv6 Zone Identifiers in Address Literals and Uniform Resource Identifiers
> https://datatracker.ietf.org/doc/draft-ietf-6man-rfc6874bis/ <https://datatracker.ietf.org/doc/draft-ietf-6man-rfc6874bis/>
> 
> https://www.ietf.org/archive/id/draft-ietf-6man-rfc6874bis-00.html <https://www.ietf.org/archive/id/draft-ietf-6man-rfc6874bis-00.html>
> 
> 
> Internet-Drafts are also available by rsync at rsync.ietf.org::internet-drafts
> 
> 
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/i-d-announce <https://www.ietf.org/mailman/listinfo/i-d-announce>
> Internet-Draft directories: http://www.ietf.org/shadow.html <http://www.ietf.org/shadow.html>
> or ftp://ftp.ietf.org/ietf/1shadow-sites.txt <ftp://ftp.ietf.org/ietf/1shadow-sites.txt>
> 
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/dispatch <https://www.ietf.org/mailman/listinfo/dispatch>

---

From: ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]>
Date: Sun, 20 Mar 2022 16:38:38 -0400

Ira,

Lovely, so they continue down the road of breaking URI validation based on STD 66...

And if the zone identifier is a simple number (Windows) or the first two characters of the interface name are valid hex digits (possible on all Unix's) then you have the issue of ambiguous decoding of the URI as well...

I guess I need to re-subscribe to the 6man list so I can provide feedback... :/

> Internet-Drafts are also available by rsync at rsync.ietf.org::internet-drafts

________________________
Michael Sweet

---

From: ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]>
Date: Sun, 20 Mar 2022 17:09:07 -0400

Smith,

My thoughts on what 6man published 10 years after the URI WG abandoned the work can be found in the 6man list archive... Let's just say they didn't like my candor... :)

To catch people up:

0. The URI workgroup published the original URI specification (RFC 3986) that supports IPv6 addresses but not link-local addresses containing zone identifiers. The RFC provides an extension point for IPv6 addresses (using a "v1." prefix. This is now STD 66.

1. The URI workgroup proposed the "v1." syntax using "+" as the zone ID separator, e.g., "[v1.abcd:1234::5678+zoneid]" but never published. CUPS implemented support for this syntax when it was first proposed, showing that it worked and was interoperable. AirPrint also requires support for this syntax...

2. The 6man workgroup published RFC 6874 using "%" as the zone ID separator, e.g. "[abcd:1234::5678%23zoneid]" but RFC 3986 (STD 66) doesn't allow those characters in the IPv6 address field. The RFC also prevents HTTP servers from returning the client-supplied zone identifier when returning URIs pointing at the server.

I need to read the whole thing through to see what's changed, but I'm going to push for allowing the "vFUTURE" syntax and avoid any ambiguous syntax...

> On Mar 20, 2022, at 4:32 PM, Kennedy, Smith (Wireless & IPP Standards) <[email-masked]> wrote:
> 

________________________
Michael Sweet

---

From: ISTO-PWG Internet Printing Protocol workgroup discussion forum via ipp <[email-masked]>
Date: Sun, 20 Mar 2022 19:13:34 -0400

Hi Mike,

I've been watching this one for awhile as an independent submission from
Brian Carpenter et al.  But now they've gotten 6man WG adoption, so it
would be worthwhile pointing out that they're going further in the direction
of breaking STD66...

Of course the joint IETF/W3C URI review list should eventually complain,
but as long as a few browsers have work-around-hacks, they don't seem
to make much headway at unwise breakage of general URI parsers.

Cheers,
- Ira

*Ira McDonald (Musician / Software Architect)*

*Chair - SAE Trust Anchors and Authentication TF*
*Co-Chair - TCG Trusted Mobility Solutions WG*

*Co-Chair - TCG Metadata Access Protocol SG*

*Chair - Linux Foundation Open Printing WGSecretary - IEEE-ISTO Printer
Working GroupCo-Chair - IEEE-ISTO PWG Internet Printing Protocol WGIETF
Designated Expert - IPP & Printer MIBBlue Roof Music / High North
Inchttp://sites.google.com/site/blueroofmusic
<http://sites.google.com/site/blueroofmusic>http://sites.google.com/site/highnorthinc
<http://sites.google.com/site/highnorthinc>mailto: [email-masked]
<[email-masked]>(permanent) PO Box 221  Grand Marais, MI 49839
906-494-2434*

On Sun, Mar 20, 2022 at 4:38 PM Michael Sweet <[email-masked]> wrote:

> And if the zone identifier is a simple number (Windows) or the first two
> characters of the interface name are valid hex digits (possible on all
> Unix's) then you have the issue of ambiguous decoding of the URI as well...
>
> > On Mar 20, 2022, at 4:02 PM, ISTO-PWG Internet Printing Protocol
> workgroup discussion forum via ipp <[email-masked]> wrote:
> >